import{S as Tt,i as Dt,s as Ct,e as l,k as u,w as L,t as n,M as Nt,c as r,d as t,m,a as p,x as P,h as o,b as g,G as a,g as i,y as T,L as Ot,q as D,o as C,B as N,v as Mt}from"../../chunks/vendor-hf-doc-builder.js";import{I as Yt}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as F}from"../../chunks/CodeBlock-hf-doc-builder.js";function Gt(mt){let f,ie,d,y,J,_,Le,Q,Pe,ne,O,Te,oe,w,De,V,Ce,Ne,le,v,Oe,M,Me,Ye,re,b,Ge,X,He,Re,pe,$,ue,Y,Ue,me,E,ce,G,ze,he,x,fe,H,Be,de,h,Ke,q,We,Fe,Z,Je,Qe,ge,R,Ve,ye,A,we,U,Xe,ve,I,be,z,Ze,ke,j,_e,B,et,$e,K,tt,Ee,c,ee,at,st,te,it,nt,ae,ot,lt,S,rt,se,pt,ut,xe;return _=new Yt({}),$=new F({props:{code:`from transformers import pipeline

asr = pipeline("automatic-speech-recognition")`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> pipeline

asr = pipeline(<span class="hljs-string">&quot;automatic-speech-recognition&quot;</span>)`}}),E=new F({props:{code:`example = minds[0]
asr(example["audio"]["array"])
{"text": "I WOULD LIKE TO PAY MY ELECTRICITY BILL USING MY COD CAN YOU PLEASE ASSIST"}`,highlighted:`example = minds[<span class="hljs-number">0</span>]
asr(example[<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>])
{<span class="hljs-string">&quot;text&quot;</span>: <span class="hljs-string">&quot;I WOULD LIKE TO PAY MY ELECTRICITY BILL USING MY COD CAN YOU PLEASE ASSIST&quot;</span>}`}}),x=new F({props:{code:`example["english_transcription"]
"I would like to pay my electricity bill using my card can you please assist"`,highlighted:`example[<span class="hljs-string">&quot;english_transcription&quot;</span>]
<span class="hljs-string">&quot;I would like to pay my electricity bill using my card can you please assist&quot;</span>`}}),A=new F({props:{code:`from datasets import load_dataset
from datasets import Audio

minds = load_dataset("PolyAI/minds14", name="de-DE", split="train")
minds = minds.cast_column("audio", Audio(sampling_rate=16_000))`,highlighted:`<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Audio

minds = load_dataset(<span class="hljs-string">&quot;PolyAI/minds14&quot;</span>, name=<span class="hljs-string">&quot;de-DE&quot;</span>, split=<span class="hljs-string">&quot;train&quot;</span>)
minds = minds.cast_column(<span class="hljs-string">&quot;audio&quot;</span>, Audio(sampling_rate=<span class="hljs-number">16_000</span>))`}}),I=new F({props:{code:`example = minds[0]
example["transcription"]
"ich m\xF6chte gerne Geld auf mein Konto einzahlen"`,highlighted:`example = minds[<span class="hljs-number">0</span>]
example[<span class="hljs-string">&quot;transcription&quot;</span>]
<span class="hljs-string">&quot;ich m\xF6chte gerne Geld auf mein Konto einzahlen&quot;</span>`}}),j=new F({props:{code:`from transformers import pipeline

asr = pipeline("automatic-speech-recognition", model="maxidl/wav2vec2-large-xlsr-german")
asr(example["audio"]["array"])
{"text": "ich m\xF6chte gerne geld auf mein konto einzallen"}`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> pipeline

asr = pipeline(<span class="hljs-string">&quot;automatic-speech-recognition&quot;</span>, model=<span class="hljs-string">&quot;maxidl/wav2vec2-large-xlsr-german&quot;</span>)
asr(example[<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>])
{<span class="hljs-string">&quot;text&quot;</span>: <span class="hljs-string">&quot;ich m\xF6chte gerne geld auf mein konto einzallen&quot;</span>}`}}),{c(){f=l("meta"),ie=u(),d=l("h1"),y=l("a"),J=l("span"),L(_.$$.fragment),Le=u(),Q=l("span"),Pe=n("Automatic speech recognition with a pipeline"),ne=u(),O=l("p"),Te=n(`Automatic Speech Recognition (ASR) is a task that involves transcribing speech audio recording into text.
This task has has numerous practical applications, from creating closed captions for videos to enabling voice commands
for virtual assistants like Siri and Alexa.`),oe=u(),w=l("p"),De=n("In this section, we\u2019ll use the "),V=l("code"),Ce=n("automatic-speech-recognition"),Ne=n(` pipeline to transcribe an audio recording of a person
asking a question about paying a bill using the same MINDS-14 dataset as before.`),le=u(),v=l("p"),Oe=n("To get started, load the datas  et and upsample it to 16kHz as described in "),M=l("a"),Me=n("Audio classification with a pipeline"),Ye=n(`,
if you haven\u2019t done that yet.`),re=u(),b=l("p"),Ge=n("To transcribe an audio recording, we can use the "),X=l("code"),He=n("automatic-speech-recognition"),Re=n(` pipeline from \u{1F917} Transformers. Let\u2019s
instantiate the pipeline:`),pe=u(),L($.$$.fragment),ue=u(),Y=l("p"),Ue=n("Next, we\u2019ll take an example from the dataset and pass its raw data to the pipeline:"),me=u(),L(E.$$.fragment),ce=u(),G=l("p"),ze=n("Let\u2019s compare this output to what the actual transcription for this example is:"),he=u(),L(x.$$.fragment),fe=u(),H=l("p"),Be=n(`The model seems to have done a pretty good job at transcribing the audio! It only got one word wrong (\u201Ccard\u201D) compared
to the original transcription, which is pretty good considering the speaker has an Australian accent, where the letter \u201Cr\u201D
is often silent. Having said that, I wouldn\u2019t recommend trying to pay your next electricity bill with a fish!`),de=u(),h=l("p"),Ke=n(`By default, this pipeline uses a model trained for automatic speech recognition for English language, which is fine in
this example. If you\u2019d like to try transcribing other subsets of MINDS-14 in different language, you can find a pre-trained
ASR model `),q=l("a"),We=n("on the \u{1F917} Hub"),Fe=n(`.
You can filter the models list by task first, then by language. Once you have found the model you like, pass it\u2019s name as
the `),Z=l("code"),Je=n("model"),Qe=n(" argument to the pipeline."),ge=u(),R=l("p"),Ve=n("Let\u2019s try this for the German split of the MINDS-14. Load the \u201Cde-DE\u201D subset:"),ye=u(),L(A.$$.fragment),we=u(),U=l("p"),Xe=n("Get an example and see what the transcription is supposed to be:"),ve=u(),L(I.$$.fragment),be=u(),z=l("p"),Ze=n("Find a pre-trained ASR model for German language on the \u{1F917} Hub, instantiate a pipeline, and transcribe the example:"),ke=u(),L(j.$$.fragment),_e=u(),B=l("p"),et=n("Also, stimmt\u2019s!"),$e=u(),K=l("p"),tt=n(`When working on solving your own task, starting with a simple pipeline like the ones we\u2019ve shown in this unit is a valuable
tool that offers several benefits:`),Ee=u(),c=l("ul"),ee=l("li"),at=n("a pre-trained model may exist that already solves your task really well, saving you plenty of time"),st=u(),te=l("li"),it=n(`pipeline() takes care of all the pre/post-processing for you, so you don\u2019t have to worry about getting the data into
the right format for a model`),nt=u(),ae=l("li"),ot=n("if the result isn\u2019t ideal, this still gives you a quick baseline for future fine-tuning"),lt=u(),S=l("li"),rt=n(`once you fine-tune a model on your custom data and share it on Hub, the whole community will be able to use it quickly
and effortlessly via the `),se=l("code"),pt=n("pipeline()"),ut=n(" method making AI more accessible."),this.h()},l(e){const s=Nt('[data-svelte="svelte-1phssyn"]',document.head);f=r(s,"META",{name:!0,content:!0}),s.forEach(t),ie=m(e),d=r(e,"H1",{class:!0});var qe=p(d);y=r(qe,"A",{id:!0,class:!0,href:!0});var ct=p(y);J=r(ct,"SPAN",{});var ht=p(J);P(_.$$.fragment,ht),ht.forEach(t),ct.forEach(t),Le=m(qe),Q=r(qe,"SPAN",{});var ft=p(Q);Pe=o(ft,"Automatic speech recognition with a pipeline"),ft.forEach(t),qe.forEach(t),ne=m(e),O=r(e,"P",{});var dt=p(O);Te=o(dt,`Automatic Speech Recognition (ASR) is a task that involves transcribing speech audio recording into text.
This task has has numerous practical applications, from creating closed captions for videos to enabling voice commands
for virtual assistants like Siri and Alexa.`),dt.forEach(t),oe=m(e),w=r(e,"P",{});var Ae=p(w);De=o(Ae,"In this section, we\u2019ll use the "),V=r(Ae,"CODE",{});var gt=p(V);Ce=o(gt,"automatic-speech-recognition"),gt.forEach(t),Ne=o(Ae,` pipeline to transcribe an audio recording of a person
asking a question about paying a bill using the same MINDS-14 dataset as before.`),Ae.forEach(t),le=m(e),v=r(e,"P",{});var Ie=p(v);Oe=o(Ie,"To get started, load the datas  et and upsample it to 16kHz as described in "),M=r(Ie,"A",{href:!0});var yt=p(M);Me=o(yt,"Audio classification with a pipeline"),yt.forEach(t),Ye=o(Ie,`,
if you haven\u2019t done that yet.`),Ie.forEach(t),re=m(e),b=r(e,"P",{});var je=p(b);Ge=o(je,"To transcribe an audio recording, we can use the "),X=r(je,"CODE",{});var wt=p(X);He=o(wt,"automatic-speech-recognition"),wt.forEach(t),Re=o(je,` pipeline from \u{1F917} Transformers. Let\u2019s
instantiate the pipeline:`),je.forEach(t),pe=m(e),P($.$$.fragment,e),ue=m(e),Y=r(e,"P",{});var vt=p(Y);Ue=o(vt,"Next, we\u2019ll take an example from the dataset and pass its raw data to the pipeline:"),vt.forEach(t),me=m(e),P(E.$$.fragment,e),ce=m(e),G=r(e,"P",{});var bt=p(G);ze=o(bt,"Let\u2019s compare this output to what the actual transcription for this example is:"),bt.forEach(t),he=m(e),P(x.$$.fragment,e),fe=m(e),H=r(e,"P",{});var kt=p(H);Be=o(kt,`The model seems to have done a pretty good job at transcribing the audio! It only got one word wrong (\u201Ccard\u201D) compared
to the original transcription, which is pretty good considering the speaker has an Australian accent, where the letter \u201Cr\u201D
is often silent. Having said that, I wouldn\u2019t recommend trying to pay your next electricity bill with a fish!`),kt.forEach(t),de=m(e),h=r(e,"P",{});var W=p(h);Ke=o(W,`By default, this pipeline uses a model trained for automatic speech recognition for English language, which is fine in
this example. If you\u2019d like to try transcribing other subsets of MINDS-14 in different language, you can find a pre-trained
ASR model `),q=r(W,"A",{href:!0,rel:!0});var _t=p(q);We=o(_t,"on the \u{1F917} Hub"),_t.forEach(t),Fe=o(W,`.
You can filter the models list by task first, then by language. Once you have found the model you like, pass it\u2019s name as
the `),Z=r(W,"CODE",{});var $t=p(Z);Je=o($t,"model"),$t.forEach(t),Qe=o(W," argument to the pipeline."),W.forEach(t),ge=m(e),R=r(e,"P",{});var Et=p(R);Ve=o(Et,"Let\u2019s try this for the German split of the MINDS-14. Load the \u201Cde-DE\u201D subset:"),Et.forEach(t),ye=m(e),P(A.$$.fragment,e),we=m(e),U=r(e,"P",{});var xt=p(U);Xe=o(xt,"Get an example and see what the transcription is supposed to be:"),xt.forEach(t),ve=m(e),P(I.$$.fragment,e),be=m(e),z=r(e,"P",{});var qt=p(z);Ze=o(qt,"Find a pre-trained ASR model for German language on the \u{1F917} Hub, instantiate a pipeline, and transcribe the example:"),qt.forEach(t),ke=m(e),P(j.$$.fragment,e),_e=m(e),B=r(e,"P",{});var At=p(B);et=o(At,"Also, stimmt\u2019s!"),At.forEach(t),$e=m(e),K=r(e,"P",{});var It=p(K);tt=o(It,`When working on solving your own task, starting with a simple pipeline like the ones we\u2019ve shown in this unit is a valuable
tool that offers several benefits:`),It.forEach(t),Ee=m(e),c=r(e,"UL",{});var k=p(c);ee=r(k,"LI",{});var jt=p(ee);at=o(jt,"a pre-trained model may exist that already solves your task really well, saving you plenty of time"),jt.forEach(t),st=m(k),te=r(k,"LI",{});var St=p(te);it=o(St,`pipeline() takes care of all the pre/post-processing for you, so you don\u2019t have to worry about getting the data into
the right format for a model`),St.forEach(t),nt=m(k),ae=r(k,"LI",{});var Lt=p(ae);ot=o(Lt,"if the result isn\u2019t ideal, this still gives you a quick baseline for future fine-tuning"),Lt.forEach(t),lt=m(k),S=r(k,"LI",{});var Se=p(S);rt=o(Se,`once you fine-tune a model on your custom data and share it on Hub, the whole community will be able to use it quickly
and effortlessly via the `),se=r(Se,"CODE",{});var Pt=p(se);pt=o(Pt,"pipeline()"),Pt.forEach(t),ut=o(Se," method making AI more accessible."),Se.forEach(t),k.forEach(t),this.h()},h(){g(f,"name","hf:doc:metadata"),g(f,"content",JSON.stringify(Ht)),g(y,"id","automatic-speech-recognition-with-a-pipeline"),g(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),g(y,"href","#automatic-speech-recognition-with-a-pipeline"),g(d,"class","relative group"),g(M,"href","audio_applications.mdx"),g(q,"href","https://huggingface.co/models?pipeline_tag=automatic-speech-recognition&language=fr&sort=downloads"),g(q,"rel","nofollow")},m(e,s){a(document.head,f),i(e,ie,s),i(e,d,s),a(d,y),a(y,J),T(_,J,null),a(d,Le),a(d,Q),a(Q,Pe),i(e,ne,s),i(e,O,s),a(O,Te),i(e,oe,s),i(e,w,s),a(w,De),a(w,V),a(V,Ce),a(w,Ne),i(e,le,s),i(e,v,s),a(v,Oe),a(v,M),a(M,Me),a(v,Ye),i(e,re,s),i(e,b,s),a(b,Ge),a(b,X),a(X,He),a(b,Re),i(e,pe,s),T($,e,s),i(e,ue,s),i(e,Y,s),a(Y,Ue),i(e,me,s),T(E,e,s),i(e,ce,s),i(e,G,s),a(G,ze),i(e,he,s),T(x,e,s),i(e,fe,s),i(e,H,s),a(H,Be),i(e,de,s),i(e,h,s),a(h,Ke),a(h,q),a(q,We),a(h,Fe),a(h,Z),a(Z,Je),a(h,Qe),i(e,ge,s),i(e,R,s),a(R,Ve),i(e,ye,s),T(A,e,s),i(e,we,s),i(e,U,s),a(U,Xe),i(e,ve,s),T(I,e,s),i(e,be,s),i(e,z,s),a(z,Ze),i(e,ke,s),T(j,e,s),i(e,_e,s),i(e,B,s),a(B,et),i(e,$e,s),i(e,K,s),a(K,tt),i(e,Ee,s),i(e,c,s),a(c,ee),a(ee,at),a(c,st),a(c,te),a(te,it),a(c,nt),a(c,ae),a(ae,ot),a(c,lt),a(c,S),a(S,rt),a(S,se),a(se,pt),a(S,ut),xe=!0},p:Ot,i(e){xe||(D(_.$$.fragment,e),D($.$$.fragment,e),D(E.$$.fragment,e),D(x.$$.fragment,e),D(A.$$.fragment,e),D(I.$$.fragment,e),D(j.$$.fragment,e),xe=!0)},o(e){C(_.$$.fragment,e),C($.$$.fragment,e),C(E.$$.fragment,e),C(x.$$.fragment,e),C(A.$$.fragment,e),C(I.$$.fragment,e),C(j.$$.fragment,e),xe=!1},d(e){t(f),e&&t(ie),e&&t(d),N(_),e&&t(ne),e&&t(O),e&&t(oe),e&&t(w),e&&t(le),e&&t(v),e&&t(re),e&&t(b),e&&t(pe),N($,e),e&&t(ue),e&&t(Y),e&&t(me),N(E,e),e&&t(ce),e&&t(G),e&&t(he),N(x,e),e&&t(fe),e&&t(H),e&&t(de),e&&t(h),e&&t(ge),e&&t(R),e&&t(ye),N(A,e),e&&t(we),e&&t(U),e&&t(ve),N(I,e),e&&t(be),e&&t(z),e&&t(ke),N(j,e),e&&t(_e),e&&t(B),e&&t($e),e&&t(K),e&&t(Ee),e&&t(c)}}}const Ht={local:"automatic-speech-recognition-with-a-pipeline",title:"Automatic speech recognition with a pipeline"};function Rt(mt){return Mt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Kt extends Tt{constructor(f){super();Dt(this,f,Rt,Gt,Ct,{})}}export{Kt as default,Ht as metadata};
