import{S as ns,i as is,s as ls,e as l,k as p,w as S,t as o,M as rs,c as r,d as s,m as u,a as c,x as C,h as n,b as w,G as t,g as i,y as M,L as cs,q as H,o as O,B as U,v as ps}from"../../chunks/vendor-hf-doc-builder.js";import{I as us}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as V}from"../../chunks/CodeBlock-hf-doc-builder.js";function ds(We){let m,X,y,b,z,q,ye,B,be,Y,A,ge,Z,P,_e,ee,d,we,v,qe,ve,W,$e,je,se,g,ke,J,xe,Ee,te,$,ae,f,Ae,G,Pe,Ie,R,Ne,Te,oe,j,ne,I,Le,ie,k,le,h,De,F,Se,Ce,K,Me,He,re,x,ce,N,Oe,pe,E,ue,_,Ue,Q,ze,Be,de;return q=new us({}),$=new V({props:{code:`from datasets import load_dataset
from datasets import Audio

minds = load_dataset("PolyAI/minds14", name="en-AU", split="train")
minds = minds.cast_column("audio", Audio(sampling_rate=16_000))`,highlighted:`<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Audio

minds = load_dataset(<span class="hljs-string">&quot;PolyAI/minds14&quot;</span>, name=<span class="hljs-string">&quot;en-AU&quot;</span>, split=<span class="hljs-string">&quot;train&quot;</span>)
minds = minds.cast_column(<span class="hljs-string">&quot;audio&quot;</span>, Audio(sampling_rate=<span class="hljs-number">16_000</span>))`}}),j=new V({props:{code:`from transformers import pipeline

classifier = pipeline(
    "audio-classification",
    model="anton-l/xtreme_s_xlsr_300m_minds14",
)`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> pipeline

classifier = pipeline(
    <span class="hljs-string">&quot;audio-classification&quot;</span>,
    model=<span class="hljs-string">&quot;anton-l/xtreme_s_xlsr_300m_minds14&quot;</span>,
)`}}),k=new V({props:{code:"example = minds[0]",highlighted:'example = minds[<span class="hljs-number">0</span>]'}}),x=new V({props:{code:`classifier(example["audio"]["array"])
[
    {"score": 0.9631525278091431, "label": "pay_bill"},
    {"score": 0.02819698303937912, "label": "freeze"},
    {"score": 0.0032787492964416742, "label": "card_issues"},
    {"score": 0.0019414445850998163, "label": "abroad"},
    {"score": 0.0008378693601116538, "label": "high_value_payment"},
]`,highlighted:`classifier(example[<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>])
[
    {<span class="hljs-string">&quot;score&quot;</span>: <span class="hljs-number">0.9631525278091431</span>, <span class="hljs-string">&quot;label&quot;</span>: <span class="hljs-string">&quot;pay_bill&quot;</span>},
    {<span class="hljs-string">&quot;score&quot;</span>: <span class="hljs-number">0.02819698303937912</span>, <span class="hljs-string">&quot;label&quot;</span>: <span class="hljs-string">&quot;freeze&quot;</span>},
    {<span class="hljs-string">&quot;score&quot;</span>: <span class="hljs-number">0.0032787492964416742</span>, <span class="hljs-string">&quot;label&quot;</span>: <span class="hljs-string">&quot;card_issues&quot;</span>},
    {<span class="hljs-string">&quot;score&quot;</span>: <span class="hljs-number">0.0019414445850998163</span>, <span class="hljs-string">&quot;label&quot;</span>: <span class="hljs-string">&quot;abroad&quot;</span>},
    {<span class="hljs-string">&quot;score&quot;</span>: <span class="hljs-number">0.0008378693601116538</span>, <span class="hljs-string">&quot;label&quot;</span>: <span class="hljs-string">&quot;high_value_payment&quot;</span>},
]`}}),E=new V({props:{code:`id2label = minds.features["intent_class"].int2str
id2label(example["intent_class"])
"pay_bill"`,highlighted:`id2label = minds.features[<span class="hljs-string">&quot;intent_class&quot;</span>].int2str
id2label(example[<span class="hljs-string">&quot;intent_class&quot;</span>])
<span class="hljs-string">&quot;pay_bill&quot;</span>`}}),{c(){m=l("meta"),X=p(),y=l("h1"),b=l("a"),z=l("span"),S(q.$$.fragment),ye=p(),B=l("span"),be=o("Audio classification with a pipeline"),Y=p(),A=l("p"),ge=o(`Audio classification involves assigning one or more labels to an audio recording based on its content. The labels
could correspond to different sound categories, such as music, speech, or noise, or more specific categories like
bird song or car engine sounds.`),Z=p(),P=l("p"),_e=o(`Before diving into details on how the most popular audio transformers work, and before fine-tuning a custom model, let\u2019s
see how you can use an off-the-shelf pre-trained model for audio classification with only a few lines of code with \u{1F917} Transformers.`),ee=p(),d=l("p"),we=o("Let\u2019s go ahead and use the same "),v=l("a"),qe=o("MINDS-14"),ve=o(` dataset that you have explored
in the previous unit. If you recall, MINDS-14 contains recordings of people asking an e-banking system questions in several
languages and dialects, and has the `),W=l("code"),$e=o("intent_class"),je=o(" for each recording. We can classify the recordings by intent of the call."),se=p(),g=l("p"),ke=o("Just as before, let\u2019s start by loading the "),J=l("code"),xe=o("en-AU"),Ee=o(` subset of the data to try out the pipeline, and upsample it to 16kHz
sampling rate which is what most speech models require.`),te=p(),S($.$$.fragment),ae=p(),f=l("p"),Ae=o("To classify an audio recording into a set of classes, we can use the "),G=l("code"),Pe=o("audio-classification"),Ie=o(` pipeline from \u{1F917} Transformers.
In our case, we need a model that\u2019s been fine-tuned for intent classification, and specifically on
the MINDS-14 dataset. Luckily for us, the Hub has a model that does just that! Let\u2019s load it by using the `),R=l("code"),Ne=o("pipeline()"),Te=o(" function:"),oe=p(),S(j.$$.fragment),ne=p(),I=l("p"),Le=o(`This pipeline expects the audio data as a NumPy array. All the preprocessing of the raw audio data will be conveniently
handled for us by the pipeline. Let\u2019s pick an example to try it out:`),ie=p(),S(k.$$.fragment),le=p(),h=l("p"),De=o("If you recall the structure of the dataset, the raw audio data is stored in a NumPy array under "),F=l("code"),Se=o('["audio"]["array"]'),Ce=o(`, let\u2019s
pass is straight to the `),K=l("code"),Me=o("classifier"),He=o(":"),re=p(),S(x.$$.fragment),ce=p(),N=l("p"),Oe=o(`The model is very confident that the caller intended to learn about paying their bill. Let\u2019s see what the actual label for
this example is:`),pe=p(),S(E.$$.fragment),ue=p(),_=l("p"),Ue=o(`Hooray! The predicted label was correct! Here we were lucky to find a model that can classify the exact labels that we need.
A lot of the times, when dealing with a classification task, a pre-trained model\u2019s set of classes is not exactly the same
as the classes you need the model to distinguish. In this case, you can fine-tune a pre-trained model to \u201Ccalibrate\u201D it to
your exact set of class labels. We\u2019ll learn how to do this in the upcoming units. Now, let\u2019s take a look at another very
common task in speech processing, `),Q=l("em"),ze=o("automatic speech recognition"),Be=o("."),this.h()},l(e){const a=rs('[data-svelte="svelte-1phssyn"]',document.head);m=r(a,"META",{name:!0,content:!0}),a.forEach(s),X=u(e),y=r(e,"H1",{class:!0});var fe=c(y);b=r(fe,"A",{id:!0,class:!0,href:!0});var Je=c(b);z=r(Je,"SPAN",{});var Ge=c(z);C(q.$$.fragment,Ge),Ge.forEach(s),Je.forEach(s),ye=u(fe),B=r(fe,"SPAN",{});var Re=c(B);be=n(Re,"Audio classification with a pipeline"),Re.forEach(s),fe.forEach(s),Y=u(e),A=r(e,"P",{});var Fe=c(A);ge=n(Fe,`Audio classification involves assigning one or more labels to an audio recording based on its content. The labels
could correspond to different sound categories, such as music, speech, or noise, or more specific categories like
bird song or car engine sounds.`),Fe.forEach(s),Z=u(e),P=r(e,"P",{});var Ke=c(P);_e=n(Ke,`Before diving into details on how the most popular audio transformers work, and before fine-tuning a custom model, let\u2019s
see how you can use an off-the-shelf pre-trained model for audio classification with only a few lines of code with \u{1F917} Transformers.`),Ke.forEach(s),ee=u(e),d=r(e,"P",{});var T=c(d);we=n(T,"Let\u2019s go ahead and use the same "),v=r(T,"A",{href:!0,rel:!0});var Qe=c(v);qe=n(Qe,"MINDS-14"),Qe.forEach(s),ve=n(T,` dataset that you have explored
in the previous unit. If you recall, MINDS-14 contains recordings of people asking an e-banking system questions in several
languages and dialects, and has the `),W=r(T,"CODE",{});var Ve=c(W);$e=n(Ve,"intent_class"),Ve.forEach(s),je=n(T," for each recording. We can classify the recordings by intent of the call."),T.forEach(s),se=u(e),g=r(e,"P",{});var he=c(g);ke=n(he,"Just as before, let\u2019s start by loading the "),J=r(he,"CODE",{});var Xe=c(J);xe=n(Xe,"en-AU"),Xe.forEach(s),Ee=n(he,` subset of the data to try out the pipeline, and upsample it to 16kHz
sampling rate which is what most speech models require.`),he.forEach(s),te=u(e),C($.$$.fragment,e),ae=u(e),f=r(e,"P",{});var L=c(f);Ae=n(L,"To classify an audio recording into a set of classes, we can use the "),G=r(L,"CODE",{});var Ye=c(G);Pe=n(Ye,"audio-classification"),Ye.forEach(s),Ie=n(L,` pipeline from \u{1F917} Transformers.
In our case, we need a model that\u2019s been fine-tuned for intent classification, and specifically on
the MINDS-14 dataset. Luckily for us, the Hub has a model that does just that! Let\u2019s load it by using the `),R=r(L,"CODE",{});var Ze=c(R);Ne=n(Ze,"pipeline()"),Ze.forEach(s),Te=n(L," function:"),L.forEach(s),oe=u(e),C(j.$$.fragment,e),ne=u(e),I=r(e,"P",{});var es=c(I);Le=n(es,`This pipeline expects the audio data as a NumPy array. All the preprocessing of the raw audio data will be conveniently
handled for us by the pipeline. Let\u2019s pick an example to try it out:`),es.forEach(s),ie=u(e),C(k.$$.fragment,e),le=u(e),h=r(e,"P",{});var D=c(h);De=n(D,"If you recall the structure of the dataset, the raw audio data is stored in a NumPy array under "),F=r(D,"CODE",{});var ss=c(F);Se=n(ss,'["audio"]["array"]'),ss.forEach(s),Ce=n(D,`, let\u2019s
pass is straight to the `),K=r(D,"CODE",{});var ts=c(K);Me=n(ts,"classifier"),ts.forEach(s),He=n(D,":"),D.forEach(s),re=u(e),C(x.$$.fragment,e),ce=u(e),N=r(e,"P",{});var as=c(N);Oe=n(as,`The model is very confident that the caller intended to learn about paying their bill. Let\u2019s see what the actual label for
this example is:`),as.forEach(s),pe=u(e),C(E.$$.fragment,e),ue=u(e),_=r(e,"P",{});var me=c(_);Ue=n(me,`Hooray! The predicted label was correct! Here we were lucky to find a model that can classify the exact labels that we need.
A lot of the times, when dealing with a classification task, a pre-trained model\u2019s set of classes is not exactly the same
as the classes you need the model to distinguish. In this case, you can fine-tune a pre-trained model to \u201Ccalibrate\u201D it to
your exact set of class labels. We\u2019ll learn how to do this in the upcoming units. Now, let\u2019s take a look at another very
common task in speech processing, `),Q=r(me,"EM",{});var os=c(Q);ze=n(os,"automatic speech recognition"),os.forEach(s),Be=n(me,"."),me.forEach(s),this.h()},h(){w(m,"name","hf:doc:metadata"),w(m,"content",JSON.stringify(fs)),w(b,"id","audio-classification-with-a-pipeline"),w(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),w(b,"href","#audio-classification-with-a-pipeline"),w(y,"class","relative group"),w(v,"href","https://huggingface.co/datasets/PolyAI/minds14"),w(v,"rel","nofollow")},m(e,a){t(document.head,m),i(e,X,a),i(e,y,a),t(y,b),t(b,z),M(q,z,null),t(y,ye),t(y,B),t(B,be),i(e,Y,a),i(e,A,a),t(A,ge),i(e,Z,a),i(e,P,a),t(P,_e),i(e,ee,a),i(e,d,a),t(d,we),t(d,v),t(v,qe),t(d,ve),t(d,W),t(W,$e),t(d,je),i(e,se,a),i(e,g,a),t(g,ke),t(g,J),t(J,xe),t(g,Ee),i(e,te,a),M($,e,a),i(e,ae,a),i(e,f,a),t(f,Ae),t(f,G),t(G,Pe),t(f,Ie),t(f,R),t(R,Ne),t(f,Te),i(e,oe,a),M(j,e,a),i(e,ne,a),i(e,I,a),t(I,Le),i(e,ie,a),M(k,e,a),i(e,le,a),i(e,h,a),t(h,De),t(h,F),t(F,Se),t(h,Ce),t(h,K),t(K,Me),t(h,He),i(e,re,a),M(x,e,a),i(e,ce,a),i(e,N,a),t(N,Oe),i(e,pe,a),M(E,e,a),i(e,ue,a),i(e,_,a),t(_,Ue),t(_,Q),t(Q,ze),t(_,Be),de=!0},p:cs,i(e){de||(H(q.$$.fragment,e),H($.$$.fragment,e),H(j.$$.fragment,e),H(k.$$.fragment,e),H(x.$$.fragment,e),H(E.$$.fragment,e),de=!0)},o(e){O(q.$$.fragment,e),O($.$$.fragment,e),O(j.$$.fragment,e),O(k.$$.fragment,e),O(x.$$.fragment,e),O(E.$$.fragment,e),de=!1},d(e){s(m),e&&s(X),e&&s(y),U(q),e&&s(Y),e&&s(A),e&&s(Z),e&&s(P),e&&s(ee),e&&s(d),e&&s(se),e&&s(g),e&&s(te),U($,e),e&&s(ae),e&&s(f),e&&s(oe),U(j,e),e&&s(ne),e&&s(I),e&&s(ie),U(k,e),e&&s(le),e&&s(h),e&&s(re),U(x,e),e&&s(ce),e&&s(N),e&&s(pe),U(E,e),e&&s(ue),e&&s(_)}}}const fs={local:"audio-classification-with-a-pipeline",title:"Audio classification with a pipeline"};function hs(We){return ps(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class gs extends ns{constructor(m){super();is(this,m,hs,ds,ls,{})}}export{gs as default,fs as metadata};
